#version 150 compatibility
#extension GL_EXT_geometry_shader4 : enable
# 1 "sphere.geom.i"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "sphere.geom.i"





uniform vec4 iris_Viewport;

# 1 "./sphere.glsl"
# 25 "./sphere.glsl"
bool sphereBBox(vec4 Po, float r,
  out vec4 ssbb, out vec2 zrange)
{
    ssbb = vec4(-1,-1,1,1); zrange = vec2(-1,1);


    mat4 MVP_i = gl_ModelViewMatrixInverse*gl_ProjectionMatrixInverse;




    mat4 Qi = mat4(-r*r); Qi[3][3] = 1.;





    vec3 vn = normalize(transpose(gl_ModelViewProjectionMatrix)[2].xyz);
# 52 "./sphere.glsl"
    vec4 z0 = vec4(vn*Po.w, -dot(vn,Po.xyz) + r*Po.w)*MVP_i;
    vec4 z1 = vec4(vn*Po.w, -dot(vn,Po.xyz) - r*Po.w)*MVP_i;
    zrange.x = max(-z0.w, -z0.z) / z0.z;
    zrange.y = min(-z1.w, z1.z) / z1.z;


    if (zrange.x > 1 || zrange.y < -1) return true;



    mat4 Trans = mat4(Po.w); Trans[3].xyz = Po.xyz;
    mat4 xform = gl_ModelViewProjectionMatrix*Trans;
    Qi = xform*Qi*transpose(xform);






    float a = Qi[3][3];
    vec2 b = Qi[3].xy;
    vec2 c = vec2(Qi[0][0],Qi[1][1]);
    vec2 d = sqrt(b*b-a*c);



    ssbb = vec4(b-d, b+d);
    ssbb = clamp(ssbb, -a,a)/a;
    if (any(equal(ssbb, vec4(1,1,-1,-1)))) return true;
    ssbb = mix(ssbb, vec4(-1,-1,1,1), isnan(d.xyxy));
    return false;
}
# 93 "./sphere.glsl"
bool sphereSize(vec4 Po, float r,
  out vec2 zrange, out vec4 spherePos, out float sphereSize)
{

    vec4 ssbb;


    spherePos = vec4(0,0,-1,0);
    sphereSize = 0;


    if (sphereBBox(Po, r, ssbb, zrange))
 return true;


    float pxSize = max((ssbb.z-ssbb.x)*iris_Viewport.z,
         (ssbb.w-ssbb.y)*iris_Viewport.w);
    vec2 ssSize = pxSize/iris_Viewport.zw;


    vec2 e = 0.5*(ssbb.xy + ssbb.zw - ssSize);
    if (e.x < -1.) ssbb.x = ssbb.z - ssSize.x;
    if (e.y < -1.) ssbb.y = ssbb.w - ssSize.y;
    e = 0.5*(ssbb.xy + ssbb.zw + ssSize);
    if (e.x > 1.) ssbb.z = ssbb.x + ssSize.x;
    if (e.y > 1.) ssbb.w = ssbb.y + ssSize.y;


    spherePos = vec4(.5*(ssbb.xy + ssbb.zw), zrange.y, 1.);
    sphereSize = .5*pxSize;
    return false;
}
# 9 "sphere.geom.i"

uniform float fatpointSize;
out vec4 center;
out vec2 zrange;

void main() {

    vec4 Pc = gl_ProjectionMatrixInverse * gl_PositionIn[0];
    vec4 Po = gl_ModelViewMatrixInverse * Pc;
    vec4 color = gl_FrontColorIn[0];


    vec4 ssbb; vec2 zr;
    if (sphereBBox( Po, fatpointSize, ssbb, zr))
 return;


    center = Po;
    zrange = zr;
    gl_FrontColor = color;
    gl_ClipVertex = Pc;



    gl_Position = vec4(ssbb.xy, zr.y, 1.);
    EmitVertex();

    gl_Position = vec4(ssbb.xw, zr.y, 1.);
    EmitVertex();

    gl_Position = vec4(ssbb.zy, zr.y, 1.);
    EmitVertex();

    gl_Position = vec4(ssbb.zw, zr.y, 1.);
    EmitVertex();
}
